/*
	dbase.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include <string.h>
#include <stdio.h>
#include "public.h"

char* extractgeneric(FILE* strm,char* attr); //Returns a pointer to the value of the named attribute from the given filestream Internal use only

char* extractgeneric(FILE* strm,char* attr)
{
	char sattr[33]; //Sample attribute
	char val[33]; //Value of extracted attribute
	char* out; //Output
	fpos_t pos; //Start of file
	bool fnd; //Found?
	
	memtest(out=new char[33]);
	out[0]='\0';
	fgetpos(strm,&pos);	
	fnd=false;
	while(fscanf(strm,"%s = %s\n",sattr,val)!=EOF&&!fnd)
	{
		if(strcmp(attr,sattr)==0)
		{
			strcpy(out,val);
			fsetpos(strm,&pos);
			fnd=true;			
		}
	}
	fsetpos(strm,&pos);
	return out;	
}

long extractlong(void* strm,char* attr)
{
	char* proc; //String to process
	long out; //Output
	
	proc=extractgeneric((FILE*)strm,attr);
	out=-1;
	sscanf(proc,"%ld",&out);
	delete(proc);
	return out;
}

void extractstring(void* strm,char* attr,char* put)
{
	char* proc; //String to process
	
	proc=extractgeneric((FILE*)strm,attr);
	strcpy(put,proc);
	delete(proc);
}
