/*
	equip.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include <string.h>
#include <stdio.h>
#include "config.h"
#include "public.h"
#include "defs.h"

const short EQUIPCOUNT=64; //Maximum number of equipment items in the database
equip equips[EQUIPCOUNT]; //Equipment database

void initequip()
{
	for(short i=0;i<EQUIPCOUNT;i++)
	{
		equips[i].self=i;
		equips[i].load();
	}
}

void* getequip(short indx)
{
	return &equips[indx];
}

void equip::load()
{
	char* path; //Path to load equipment data from
	FILE* strm;  //Filestream to use
	
	memtest(path=new char[strlen(DATADIR)+16]);
	sprintf(path,"%s%sequip%s%hd.eqp",DATADIR,PATHSEP,PATHSEP,self);
	strm=fopen(path,"r");
	delete(path);
	if(strm!=NULL)
	{
		extractstring(strm,"Name",nam);
		typ=extractlong(strm,"Type");
		mss=extractlong(strm,"Mass");
		spr=extractlong(strm,"Sprite");
		pow=extractlong(strm,"Power");
		rdy=extractlong(strm,"CycleTime");
		cap=extractlong(strm,"Capacity");
		rng=extractlong(strm,"Range");
		trck=extractlong(strm,"Tracking");
		acov=extractlong(strm,"Coverage");
		fclose(strm);
	}
}
